#! /bin/sh

# first  argument:  path(part1) to configfile of old repository (SiVeCo)
# second argument:  path(part3) to configfile of old repository (SiVeCo)
# third argument:   path(filename) to configfile of old repository (SiVeCo)
# fourth argument:  name of new repository (mercurial)

custom_get_revid()
{
  hg tip --template "{node}"
}

custom_commit()
{
  # todo: debug only
  # echo custom_commit ${TAG}

  if grep -q "<li>" ${MSGFILE}
    then
      cat ${MSGFILE} | sed "s/<li><\/li>//" > ${MSGFILE}.tmp
      lynx -force_html -dump ${MSGFILE}.tmp > ${MSGFILE}
      rm ${MSGFILE}.tmp
    else
      true
  fi

  echo ${TAG} > ${MSGFILE}.tmp
  echo "" >> ${MSGFILE}.tmp
  cat ${MSGFILE} >> ${MSGFILE}.tmp
  mv ${MSGFILE}.tmp ${MSGFILE}

  if ( /usr/local/bin/scripte/charset/test_is_utf8.sh ${MSGFILE} )
    then
      iconv -f iso-8859-1 -t utf-8 -o /tmp/charsetconv_$$ ${MSGFILE}
      mv /tmp/charsetconv_$$ ${MSGFILE}
  fi
    
  cp -a ${TMPDIR}/* ${REPDIR}/${REPNAME}/
  hg commit -q -A -d "${DATE}" -l ${MSGFILE}
  
  # hg tag -d "${DATE}" "${TAG}"
  # cat .hgtags
}

custom_tag()
{
  mkdir -p .SiVeCo2hg
  echo ${CURREV} ${TAG} >> ${TAGLISTTMP}
  cp ${TAGLISTTMP} ${TAGLIST}
}

custom_clean_files()
{
  # rm .hgtags
  
  rm -r ${TMPDIR}
}

custom_set_base()
{
  hg update -C -r "${BASEDON}"
}

# todo: debug only
# echo $1 $2


TMPDIR="$1/siveco2hg_$$/"
REPDIR="$1"
REPNAME="$4"
MSGFILE="$1/siveco2hg_msg_$$.txt"
TAGLISTTMP="$1/siveco2hg_tags_$$.txt"
TAGLIST=".SiVeCo2hg/tags.txt"
                                
rm -f -r ${TMPDIR}

mkdir -p ${REPDIR}
cd ${REPDIR}
rm -f -r ${REPNAME}/

hg init ${REPNAME}
cd ${REPNAME}

mkdir -p .SiVeCo2hg
rm -f ${TAGLIST}
rm -f ${TAGLISTTMP}

siveco m $1/$2/$3 > ${REPDIR}/conv_hg_$$.sh

# Wenn man noch Handarbeit machen möchte:
#exit 0

source ${REPDIR}/conv_hg_$$.sh
#source ${REPDIR}/conv_hg_17188.sh

hg commit -q -A -m "Import from SiVeCo done."

rm -f ${TAGLISTTMP}
rm -f ${MSGFILE}
rm -f ${REPDIR}/conv_hg_$$.sh

echo "Done: "$1 $2 $3 $4
