/*
 * Copyright (C) 2004  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef SIVECOCREATE_H
#define SIVECOCREATE_H

#include "SimpleXMLTransfer.h"
#include <string>
#include <regex.h>
#include <vector>
#include "types.h"

class SiVeCoCreate
{
  public:
   SiVeCoCreate(SimpleXMLTransfer* ptr_conf,
                std::string        workingDir,
                eCmd               i_cmd);
   
   int run(int         nNr,
           std::string type,
           std::string label);

  private:     
   std::string         wd;           // Working directory
   std::string         targetDir;    // Directory in repository where things go to
   std::string         refDir;       // Directory in repository where previous version is
   std::string         newNrString;  
   std::string         oldNrString;  
   SimpleXMLTransfer*  conf;      
   regex_t*            exclDir;
   regex_t*            exclFile;
   eCmd                cmd;
   
   std::vector<std::string>  newFiles;
   std::vector<std::string>  changedFiles;
   std::vector<std::string>  excludedFiles;
   std::vector<std::string>  deletedFiles;
                
   bool isIncluded(regex_t*           regex,
                   const char*        name);
   int create(std::string        dir,
              SimpleXMLTransfer* ofile);
   int fillDeletedFileList(std::string    dir);
   
   int   compileRegEx();
   void  freeRegEx();
   
   std::string getOriginalFileRel(std::string path,
                                  std::string refDir);

};

#endif
