/*
 * Copyright (C) 2004, 2007  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef SIVECOGET_H
# define SIVECOGET_H

# include "SimpleXMLTransfer.h"
# include <string>
# include <iconv.h>
# include "types.h"

class SiVeCoGet
{
public:
  SiVeCoGet(SimpleXMLTransfer* ptr_conf,
            std::string        workingDir,
            eCmd               i_cmd);
  
  int run(int         nNr,
          std::string type,
          bool        fQuiet);
  
private:     
  std::string         wd;           // Working directory
  std::string         rd;           // Directory in repository
  SimpleXMLTransfer*  conf;
  SimpleXMLTransfer*  logfile;
  eCmd                cmd;
  iconv_t             charsetconv;
  
  int get(std::string         dir,
          SimpleXMLTransfer*  links);
};

#endif
