/*
 * Copyright (C) 2004  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef SIVECOREMOVE_H
#define SIVECOREMOVE_H

#include "SimpleXMLTransfer.h"
#include <string>
#include <vector>

struct T_Items
{
  std::string name;
  bool        fUsed;
};


class SiVeCoRemove
{
  public:
   SiVeCoRemove(SimpleXMLTransfer* ptr_conf);
   
   int run(int nNrStart,
           int nNrEnd);
   
  private:     
   SimpleXMLTransfer*       conf;   
   std::vector<T_Items>     files;
   int                      nBaseChars;
   
   int  schrittEins(std::string currentDir);
   int  schrittZwei(std::string currentDir);
   bool removeEmptyDirs(std::string currentDir);
   void addToList(std::string item);
   void showList();
   int  indexInList(std::string item);
   int  findInList(std::string item);
};

#endif
