/*
 * Copyright (C) 2004  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef __TOOLS
#define __TOOLS

#include <string>
#include "SimpleXMLTransfer.h"
#include "lib_conversions.h"

bool existDir(std::string DirPfad);
bool existDat(std::string DateiPfad);

/**
 * Wohin zeigt ein Link?
 */
std::string getLinkTarget(std::string path);

/**
 * Wandelt einen relativen Pfad in einen absoluten um
 */
std::string relPathToAbs(std::string path);

/**
 *
 */
std::string getDateString();

/**
 *
 */
std::string getTimeString();

/** 
 * Get current version number as int.
 * Returns -1 if there is nothing in the repository.
 */
int getCurrentVersionNumberInt(SimpleXMLTransfer* conf);

/**
 * Get version number string
 */
inline std::string getVersionNumberString(int nNr)
{
  return(itoStr(nNr, '0', 5));
}

std::string getRelPath(std::string refPath,
                       std::string absPath);


bool canHandleFileVersion(int v);

/**
 * Liefert die Nummer zurck, von der die Version in wdir
 * abgeleitet wurde. Wenn die tracking-Datei nicht existiert,
 * wird -1 zurckgegeben.
 */
int isDerivedFrom(SimpleXMLTransfer* conf,
                  std::string        wdir);

/**
 * Fhrt ein Kommando aus dem Config-File aus. Davor
 * wird in das entsprechende Verzeichnis gewechselt.
 */
int executeCmd(std::string           cmd,
               std::string           argument);

/**
 *
 */
int setDerivedFrom(SimpleXMLTransfer* conf,
                   std::string        wdir,
                   int                nNr);

int createEmptyChangeLog(std::string filename);

int getChangeLogContent(std::string& buf,
                        std::string  filename);

std::string getConfDir(SimpleXMLTransfer* conf,
                       std::string        name);
#endif // __TOOLS
